;**********************************************************************
;  Eine Binaerzahl (0..65565) oder (-32768..32767) in ASCII wandeln
;  IN:   VALUE stored in SRAM pointered by Y [LSB]|[MSB]
;        r25    (high-Byte)
;  
;  OUT:  stored in SRAM pointered by X
;        
;**********************************************************************
int16u_ascii:
		push	r16
		push	r17
		push	r18
		push	XL
		push	XH
		load_p	X,(BCD_VALUE)
		ld		r17,Y+			; LSB
		ld		r18,Y+			; MSB
		ldi		r16,' '
		rjmp	int16_bcd_numb
int16s_ascii:
		push	r16
		push	r17
		push	r18
		push	XL
		push	XH
		load_p	X,(BCD_VALUE)
		ld		r17,Y+			; LSB
		ld		r18,Y+			; MSB
		ldi		r16,' '
		sbrs	r18,7
		rjmp	int16_bcd_numb
		ldi		r16,'-'
		com		r17
		com		r18
		add		r17,one
		adc		r18,zero
int16_bcd_numb:
		push	r16
		ldi		r16,' '
		st		X+,r16
; Zehntausenderstelle
		ldi   	r16,'0'
bcd_number5:
		subi  	r17, low(10000)
		sbci  	r18,high(10000)
		brcs	bcd_number5a
		inc		r16
		rjmp	bcd_number5
bcd_number5a:
		set
		cpi		r16,'0'
		brne	bcd_number5b
		ldi		r16,' '
		clt
bcd_number5b:
		st		X+,r16
		subi  	r17,byte1(-10000)
		sbci  	r18,byte2(-10000)

; Tausenderstelle
		ldi   	r16,'0'
bcd_number4:
		subi  	r17, low(1000)
		sbci  	r18,high(1000)
		brcs	bcd_number4a
		inc		r16
		rjmp	bcd_number4
bcd_number4a:
		brts	bcd_number4b
		set
		cpi		r16,'0'
		brne	bcd_number4b
		ldi		r16,' '
		clt	
bcd_number4b:
		st		X+,r16
		subi  	r17,byte1(-1000)
		sbci  	r18,byte2(-1000)

; Hunderterstelle
		ldi   	r16,'0'
bcd_number3:
		subi  	r17, low(100)
		sbci  	r18,high(100)
		brcs	bcd_number3a
		inc		r16
		rjmp	bcd_number3
bcd_number3a:
;------------------------------------
		brts	bcd_number3b
		set
		cpi		r16,'0'
		brne	bcd_number3b
		ldi		r16,' '
		clt
;------------------------------------
bcd_number3b:
		st		X+,r16
		subi  	r17,-100

; Zehnerstelle
		ldi		r16, '0'
bcd_number2:
		subi	r17, 10
		brcs	bcd_number2a
		inc		r16
		rjmp	bcd_number2
bcd_number2a:
;------------------------------------
		brts	bcd_number2b
		cpi		r16,'0'
		brne	bcd_number2b
		ldi		r16,' '
;------------------------------------
bcd_number2b:
		st		X+,r16
		subi  	r17,-(10 + '0')
		st		X+,r17
		ldi		r17,0
		st		X+,r17
; fertig: Stack wieder aufräumen
		clt
		ldi		XL,byte1(BCD_VALUE)
		ldi		XH,byte2(BCD_VALUE)
		ld		r16,X+
		cpi		r16,' '
		breq	PC-2
		sbiw	X,2
		pop		r16
		st		X,r16
		pop		XH
		pop		XL
		pop		r18
		pop		r17
		pop		r16
		ret
