;**********************************************************************
;  Eine Binaerzahl (0..16777216) oder (-8388608..8388607) in ASCII wandeln
;  IN:   VALUE stored in SRAM pointered by Y [BYTE.0]:[BYTE.1]:[BYTE.2]:[BYTE.3]
; 
; 
;  OUT:  stored in SRAM pointered by X; NULL termiert
;        
;**********************************************************************
int32u_ascii:
		push	r16
		push	r17
		push	r18
		push	r19
		push	r20
		push	XL
		push	XH
		load_p	X,(BCD_VALUE)
		ld		r17,Y+			; XLSB
		ld		r18,Y+			; LSB
		ld		r19,Y+			; CSB
		ld		r20,Y+			; MSB
		ldi		r16,' '
		rjmp	int32_bcd_numb
int32s_ascii:
		push	r16
		push	r17
		push	r18
		push	r19
		push	r20
		push	XL
		push	XH
		load_p	X,(BCD_VALUE)
		ld		r17,Y+			; XLSB
		ld		r18,Y+			; LSB
		ld		r19,Y+			; CSB
		ld		r20,Y+			; MSB
		ldi		r16,' '
		sbrs	r20,7
		rjmp	int32_bcd_numb
		ldi		r16,'-'
		com		r17
		com		r18
		com		r19
		com		r20
		add		r17,one
		adc		r18,zero
		adc		r19,zero
		adc		r20,zero
int32_bcd_numb:
		push	r16
		ldi		r16,' '
		st		X+,r16

; Millardste Stelle
		ldi   	r16,'0'
bcd32_number10:
		subi  	r17,byte1(1000000000)
		sbci  	r18,byte2(1000000000)
		sbci  	r19,byte3(1000000000)
		sbci  	r20,byte4(1000000000)
		brcs	bcd32_number10a
		inc		r16
		rjmp	bcd32_number10
bcd32_number10a:
		set
		cpi		r16,'0'
		brne	bcd32_number10b
		ldi		r16,' '
		clt
bcd32_number10b:
		st		X+,r16
		subi  	r17,byte1(-1000000000)
		sbci  	r18,byte2(-1000000000)
		sbci  	r19,byte3(-1000000000)
		sbci  	r20,byte4(-1000000000)


; Hundertmillionstestelle
		ldi   	r16,'0'
bcd32_number9:
		subi  	r17,byte1(100000000)
		sbci  	r18,byte2(100000000)
		sbci  	r19,byte3(100000000)
		sbci  	r20,byte4(100000000)
		brcs	bcd32_number9a
		inc		r16
		rjmp	bcd32_number9
bcd32_number9a:
		brts	bcd32_number9b
		set
		cpi		r16,'0'
		brne	bcd32_number9b
		ldi		r16,' '
		clt
bcd32_number9b:
		st		X+,r16
		subi  	r17,byte1(-100000000)
		sbci  	r18,byte2(-100000000)
		sbci  	r19,byte3(-100000000)
		sbci  	r20,byte4(-100000000)

; Zehnmillionstestelle
		ldi   	r16,'0'
bcd32_number8:
		subi  	r17,byte1(10000000)
		sbci  	r18,byte2(10000000)
		sbci  	r19,byte3(10000000)
		sbci  	r20,byte4(10000000)
		brcs	bcd32_number8a
		inc		r16
		rjmp	bcd32_number8
bcd32_number8a:
		brts	bcd32_number8b
		set
		cpi		r16,'0'
		brne	bcd32_number8b
		ldi		r16,' '
		clt
bcd32_number8b:
		st		X+,r16
		subi  	r17,byte1(-10000000)
		sbci  	r18,byte2(-10000000)
		sbci  	r19,byte3(-10000000)
		sbci  	r20,byte4(-10000000)

; Millionstestelle
		ldi   	r16,'0'
bcd32_number7:
		subi  	r17,byte1(1000000)
		sbci  	r18,byte2(1000000)
		sbci  	r19,byte3(1000000)
		brcs	bcd32_number7a
		inc		r16
		rjmp	bcd32_number7
bcd32_number7a:
		brts	bcd32_number7b
		set
		cpi		r16,'0'
		brne	bcd32_number7b
		ldi		r16,' '
		clt
bcd32_number7b:
		st		X+,r16
		subi  	r17,byte1(-1000000)
		sbci  	r18,byte2(-1000000)
		sbci  	r19,byte3(-1000000)

; Hunderttausenderstelle
		ldi   	r16,'0'
bcd32_number6:
		subi  	r17,byte1(100000)
		sbci  	r18,byte2(100000)
		sbci  	r19,byte3(100000)
		brcs	bcd32_number6a
		inc		r16
		rjmp	bcd32_number6
bcd32_number6a:
		brts	bcd32_number6b
		set
		cpi		r16,'0'
		brne	bcd32_number6b
		ldi		r16,' '
		clt
bcd32_number6b:
		st		X+,r16
		subi  	r17,byte1(-100000)
		sbci  	r18,byte2(-100000)
		sbci  	r19,byte3(-100000)

; Zehntausenderstelle
		ldi   	r16,'0'
bcd32_number5:
		subi  	r17,byte1(10000)
		sbci  	r18,byte2(10000)
		sbci  	r19,byte3(10000)
		brcs	bcd32_number5a
		inc		r16
		rjmp	bcd32_number5
bcd32_number5a:
		brts	bcd32_number5b
		set
		cpi		r16,'0'
		brne	bcd32_number5b
		ldi		r16,' '
		clt
bcd32_number5b:
		st		X+,r16
		subi  	r17,byte1(-10000)
		sbci  	r18,byte2(-10000)
		sbci  	r19,byte3(-10000)

; Tausenderstelle
		ldi   	r16,'0'
bcd32_number4:
		subi  	r17, low(1000)
		sbci  	r18,high(1000)
		brcs	bcd32_number4a
		inc		r16
		rjmp	bcd32_number4
bcd32_number4a:
		brts	bcd32_number4b
		set
		cpi		r16,'0'
		brne	bcd32_number4b
		ldi		r16,' '
		clt	
bcd32_number4b:
		st		X+,r16
		subi  	r17,byte1(-1000)
		sbci  	r18,byte2(-1000)

; Hunderterstelle
		ldi   	r16,'0'
bcd32_number3:
		subi  	r17, low(100)
		sbci  	r18,high(100)
		brcs	bcd32_number3a
		inc		r16
		rjmp	bcd32_number3
bcd32_number3a:
;------------------------------------
		brts	bcd32_number3b
		set
		cpi		r16,'0'
		brne	bcd32_number3b
		ldi		r16,' '
		clt
;------------------------------------
bcd32_number3b:
		st		X+,r16
		subi  	r17,-100

; Zehnerstelle
		ldi		r16, '0'
bcd32_number2:
		subi	r17, 10
		brcs	bcd32_number2a
		inc		r16
		rjmp	bcd32_number2
bcd32_number2a:
;------------------------------------
		brts	bcd32_number2b
		cpi		r16,'0'
		brne	bcd32_number2b
		ldi		r16,' '
;------------------------------------
bcd32_number2b:
		st		X+,r16
		subi  	r17,-(10 + '0')
		st		X+,r17
		ldi		r17,0
		st		X+,r17
; fertig: Stack wieder aufräumen
		clt
		ldi		XL,byte1(BCD_VALUE)
		ldi		XH,byte2(BCD_VALUE)
		ld		r16,X+
		cpi		r16,' '
		breq	PC-2
		sbiw	X,2
		pop		r16
		st		X,r16
		pop		XH
		pop		XL
		pop		r20
		pop		r19
		pop		r18
		pop		r17
		pop		r16
		ret
