;**********************************************************************
;  Eine Binaerzahl (0..18.446.744.073.709.551.615)
;  oder (-9.223.372.036.854.775.808..9.223.372.036.854.775.807) in ASCII wandeln
;  IN:   VALUE stored in SRAM pointered by Y [BYTE.0]:[BYTE.1]:[BYTE.2]:[BYTE.3]
; 
; 
;  OUT:  stored in SRAM pointered by X; NULL termiert
;        
;**********************************************************************
int64u_ascii:
		push	r16
		push	r17
		push	r18
		push	r19
		push	r20
		push	r21
		push	r22
		push	r23
		push	r24
		push	XL
		push	XH
		load_p	X,(BCD_VALUE)
		ld		r17,Y+			; XLSB
		ld		r18,Y+			; LSB
		ld		r19,Y+			; CSB
		ld		r20,Y+			; CSB
		ld		r21,Y+			; CSB
		ld		r22,Y+			; CSB
		ld		r23,Y+			; CSB
		ld		r24,Y+			; MSB
		ldi		r16,' '
		rjmp	int64_bcd_numb
int64s_ascii:
		push	r16
		push	r17
		push	r18
		push	r19
		push	r20
		push	r21
		push	r22
		push	r23
		push	r24
		push	XL
		push	XH
		load_p	X,(BCD_VALUE)
		ld		r17,Y+			; XLSB
		ld		r18,Y+			; LSB
		ld		r19,Y+			; CSB
		ld		r20,Y+			; CSB
		ld		r21,Y+			; CSB
		ld		r22,Y+			; CSB
		ld		r23,Y+			; CSB
		ld		r24,Y+			; MSB
		ldi		r16,' '
		sbrs	r20,7
		rjmp	int64_bcd_numb
		ldi		r16,'-'
		com		r17
		com		r18
		com		r19
		com		r20
		com		r21
		com		r22
		com		r23
		com		r24
		add		r17,one
		adc		r18,zero
		adc		r19,zero
		adc		r20,zero
		adc		r21,zero
		adc		r22,zero
		adc		r23,zero
		adc		r24,zero
int64_bcd_numb:
		push	r16
		ldi		r16,' '
		st		X+,r16
		
; 10 Trillionste Stelle 10^19
		ldi   	r16,'0'
		
bcd64_number20:
		subi  	r17,(0x00)					;(10.000.000.000.000.000.000)
		sbci  	r18,(0x00)
		sbci  	r19,(0xE8)
		sbci  	r20,(0x89)
		sbci  	r21,(0x04)
		sbci  	r22,(0x23)
		sbci  	r23,(0xC7)
		sbci  	r24,(0x8A)
		brcs	bcd64_number20a
		inc		r16
		rjmp	bcd64_number20
bcd64_number20a:
		set
		cpi		r16,'0'
		brne	bcd64_number20b
		ldi		r16,' '
		clt
bcd64_number20b:
		st		X+,r16
		subi  	r17,(0x00)					;(-10.000.000.000.000.000.000)
		sbci  	r18,(0x00)
		sbci  	r19,(0x18)
		sbci  	r20,(0x76)
		sbci  	r21,(0xFB)
		sbci  	r22,(0xDC)
		sbci  	r23,(0x38)
		sbci  	r24,(0x75)
				
; 1 Trillionste Stelle 10^18
		ldi   	r16,'0'
bcd64_number19:
		subi  	r17,(0x00)					;(1.000.000.000.000.000.000)
		sbci  	r18,(0x00)
		sbci  	r19,(0x64)
		sbci  	r20,(0xA7)
		sbci  	r21,(0xB3)
		sbci  	r22,(0xB6)
		sbci  	r23,(0xE0)
		sbci  	r24,(0x0D)
		brcs	bcd64_number19a
		inc		r16
		rjmp	bcd64_number19
bcd64_number19a:
		brts	bcd64_number19b
		set
		cpi		r16,'0'
		brne	bcd64_number19b
		ldi		r16,' '
		clt
bcd64_number19b:
		st		X+,r16
		subi  	r17,(0x00)					;(-1.000.000.000.000.000.000)
		sbci  	r18,(0x00)
		sbci  	r19,(0x9C)
		sbci  	r20,(0x58)
		sbci  	r21,(0x4C)
		sbci  	r22,(0x49)
		sbci  	r23,(0x1F)
		sbci  	r24,(0xF2)
		
; 100 Billiardste Stelle 10^17
		ldi   	r16,'0'
bcd64_number18:
		subi  	r17,(0x00)					;(100.000.000.000.000.000)
		sbci  	r18,(0x00)
		sbci  	r19,(0x8A)
		sbci  	r20,(0x5D)
		sbci  	r21,(0x78)
		sbci  	r22,(0x45)
		sbci  	r23,(0x63)
		sbci  	r24,(0x01)
		brcs	bcd64_number18a
		inc		r16
		rjmp	bcd64_number18
bcd64_number18a:
		brts	bcd64_number18b
		set
		cpi		r16,'0'
		brne	bcd64_number18b
		ldi		r16,' '
		clt
bcd64_number18b:
		st		X+,r16
		subi  	r17,(0x00)					;(-100.000.000.000.000.000)
		sbci  	r18,(0x00)
		sbci  	r19,(0x76)
		sbci  	r20,(0xA2)
		sbci  	r21,(0x87)
		sbci  	r22,(0xBA)
		sbci  	r23,(0x9C)
		sbci  	r24,(0xFE)

; 10 Billiardste Stelle 10^16
		ldi   	r16,'0'
bcd64_number17:
		subi  	r17,(0x00)					;(10.000.000.000.000.000)
		sbci  	r18,(0x00)
		sbci  	r19,(0xC1)
		sbci  	r20,(0x6F)
		sbci  	r21,(0xF2)
		sbci  	r22,(0x86)
		sbci  	r23,(0x23)
		brcs	bcd64_number17a
		inc		r16
		rjmp	bcd64_number17
bcd64_number17a:
		brts	bcd64_number17b
		set
		cpi		r16,'0'
		brne	bcd64_number17b
		ldi		r16,' '
		clt
bcd64_number17b:
		st		X+,r16
		subi  	r17,(0x00)					;(-10.000.000.000.000.000)
		sbci  	r18,(0x00)
		sbci  	r19,(0x3F)
		sbci  	r20,(0x90)
		sbci  	r21,(0x0D)
		sbci  	r22,(0x79)
		sbci  	r23,(0xDC)
		
; 1 Billiardste Stelle 10^15
		ldi   	r16,'0'
bcd64_number16:
		subi  	r17,(0x00)					;(1.000.000.000.000.000)
		sbci  	r18,(0x80)
		sbci  	r19,(0xC6)
		sbci  	r20,(0xA4)
		sbci  	r21,(0x7E)
		sbci  	r22,(0x8D)
		sbci  	r23,(0x03)
		brcs	bcd64_number16a
		inc		r16
		rjmp	bcd64_number16
bcd64_number16a:
		brts	bcd64_number16b
		set
		cpi		r16,'0'
		brne	bcd64_number16b
		ldi		r16,' '
		clt
bcd64_number16b:
		st		X+,r16
		subi  	r17,(0x00)					;(-1.000.000.000.000.000)
		sbci  	r18,(0x80)
		sbci  	r19,(0x39)
		sbci  	r20,(0x5B)
		sbci  	r21,(0x81)
		sbci  	r22,(0x72)
		sbci  	r23,(0xFC)
		
; 100 Billionste Stelle 10^14
		ldi   	r16,'0'
bcd64_number15:
		subi  	r17,(0x00)					;(100.000.000.000.000)
		sbci  	r18,(0x40)
		sbci  	r19,(0x7A)
		sbci  	r20,(0x10)
		sbci  	r21,(0xF3)
		sbci  	r22,(0x5A)
		brcs	bcd64_number15a
		inc		r16
		rjmp	bcd64_number15
bcd64_number15a:
		brts	bcd64_number15b
		set
		cpi		r16,'0'
		brne	bcd64_number15b
		ldi		r16,' '
		clt
bcd64_number15b:
		st		X+,r16
		subi  	r17,(0x00)					;(-100.000.000.000.000)
		sbci  	r18,(0xC0)
		sbci  	r19,(0x85)
		sbci  	r20,(0xEF)
		sbci  	r21,(0x0C)
		sbci  	r22,(0xA5)
		
; 10 Billionste Stelle 10^13
		ldi   	r16,'0'
bcd64_number14:
		subi  	r17,(0x00)					;(10.000.000.000.000)
		sbci  	r18,(0xA0)
		sbci  	r19,(0x72)
		sbci  	r20,(0x4E)
		sbci  	r21,(0x18)
		sbci  	r22,(0x09)
		brcs	bcd64_number14a
		inc		r16
		rjmp	bcd64_number14
bcd64_number14a:
		brts	bcd64_number14b
		set
		cpi		r16,'0'
		brne	bcd64_number14b
		ldi		r16,' '
		clt
bcd64_number14b:
		st		X+,r16
		subi  	r17,(0x00)					;(-10.000.000.000.000)
		sbci  	r18,(0x60)
		sbci  	r19,(0x8D)
		sbci  	r20,(0xB1)
		sbci  	r21,(0xE7)
		sbci  	r22,(0xF6)
		
; Billionste Stelle 10^12
		ldi   	r16,'0'
bcd64_number13:
		subi  	r17,(0x00)					;(1.000.000.000.000)
		sbci  	r18,(0x10)
		sbci  	r19,(0xA5)
		sbci  	r20,(0xD4)
		sbci  	r21,(0xE8)
		brcs	bcd64_number13a
		inc		r16
		rjmp	bcd64_number13
bcd64_number13a:
		brts	bcd64_number13b
		set
		cpi		r16,'0'
		brne	bcd64_number13b
		ldi		r16,' '
		clt
bcd64_number13b:
		st		X+,r16
		subi  	r17,(0x00)					;(-1.000.000.000.000)
		sbci  	r18,(0xF0)
		sbci  	r19,(0x5A)
		sbci  	r20,(0x2B)
		sbci  	r21,(0x17)

; Hundert Millardste Stelle 10^11
		ldi   	r16,'0'
bcd64_number12:
		subi  	r17,(0x00)					;(100.000.000.000)
		sbci  	r18,(0xE8)
		sbci  	r19,(0x76)
		sbci  	r20,(0x48)
		sbci  	r21,(0x17)
		brcs	bcd64_number12a
		inc		r16
		rjmp	bcd64_number12
bcd64_number12a:
		brts	bcd64_number12b
		set
		cpi		r16,'0'
		brne	bcd64_number12b
		ldi		r16,' '
		clt
bcd64_number12b:
		st		X+,r16
		subi  	r17,(0x00)					;(-100.000.000.000)
		sbci  	r18,(0x18)
		sbci  	r19,(0x89)
		sbci  	r20,(0xB7)
		sbci  	r21,(0xE8)

; Zehn Millardste Stelle 10^10
		ldi   	r16,'0'
bcd64_number11:
		subi  	r17,(0x00)					;(10.000.000.000)
		sbci  	r18,(0xE4)
		sbci  	r19,(0x0B)
		sbci  	r20,(0x54)
		sbci  	r21,(0x02)
		brcs	bcd64_number11a
		inc		r16
		rjmp	bcd64_number11
bcd64_number11a:
		brts	bcd64_number11b
		set
		cpi		r16,'0'
		brne	bcd64_number11b
		ldi		r16,' '
		clt
bcd64_number11b:
		st		X+,r16
		subi  	r17,(0x00)					;(-10.000.000.000)
		sbci  	r18,(0x1C)
		sbci  	r19,(0xF4)
		sbci  	r20,(0xAB)
		sbci  	r21,(0xFD)

; Millardste Stelle 10^9
		ldi   	r16,'0'
bcd64_number10:
		subi  	r17,byte1(1000000000)		;(1.000.000.000)
		sbci  	r18,byte2(1000000000)
		sbci  	r19,byte3(1000000000)
		sbci  	r20,byte4(1000000000)
		brcs	bcd64_number10a
		inc		r16
		rjmp	bcd64_number10
bcd64_number10a:
		brts	bcd64_number10b
		set
		cpi		r16,'0'
		brne	bcd64_number10b
		ldi		r16,' '
		clt
bcd64_number10b:
		st		X+,r16
		subi  	r17,byte1(-1000000000)		;(-1.000.000.000)
		sbci  	r18,byte2(-1000000000)
		sbci  	r19,byte3(-1000000000)
		sbci  	r20,byte4(-1000000000)

; Hundertmillionstestelle	10^8
		ldi   	r16,'0'
bcd64_number9:
		subi  	r17,byte1(100000000)		;(100.000.000)
		sbci  	r18,byte2(100000000)
		sbci  	r19,byte3(100000000)
		sbci  	r20,byte4(100000000)
		brcs	bcd64_number9a
		inc		r16
		rjmp	bcd64_number9
bcd64_number9a:
		brts	bcd64_number9b
		set
		cpi		r16,'0'
		brne	bcd64_number9b
		ldi		r16,' '
		clt
bcd64_number9b:
		st		X+,r16
		subi  	r17,byte1(-100000000)		;(-100.000.000)
		sbci  	r18,byte2(-100000000)
		sbci  	r19,byte3(-100000000)
		sbci  	r20,byte4(-100000000)

; Zehnmillionstestelle		10^7
		ldi   	r16,'0'
bcd64_number8:
		subi  	r17,byte1(10000000)			;(10.000.000)
		sbci  	r18,byte2(10000000)
		sbci  	r19,byte3(10000000)
		sbci  	r20,byte4(10000000)
		brcs	bcd64_number8a
		inc		r16
		rjmp	bcd64_number8
bcd64_number8a:
		brts	bcd64_number8b
		set
		cpi		r16,'0'
		brne	bcd64_number8b
		ldi		r16,' '
		clt
bcd64_number8b:
		st		X+,r16
		subi  	r17,byte1(-10000000)		;(-10.000.000)
		sbci  	r18,byte2(-10000000)
		sbci  	r19,byte3(-10000000)
		sbci  	r20,byte4(-10000000)

; Millionstestelle		10^6
		ldi   	r16,'0'
bcd64_number7:
		subi  	r17,byte1(1000000)			;(1.000.000)
		sbci  	r18,byte2(1000000)
		sbci  	r19,byte3(1000000)
		brcs	bcd64_number7a
		inc		r16
		rjmp	bcd64_number7
bcd64_number7a:
		brts	bcd64_number7b
		set
		cpi		r16,'0'
		brne	bcd64_number7b
		ldi		r16,' '
		clt
bcd64_number7b:
		st		X+,r16
		subi  	r17,byte1(-1000000)			;(-1.000.000)
		sbci  	r18,byte2(-1000000)
		sbci  	r19,byte3(-1000000)

; Hunderttausenderstelle		10^5
		ldi   	r16,'0'
bcd64_number6:
		subi  	r17,byte1(100000)
		sbci  	r18,byte2(100000)
		sbci  	r19,byte3(100000)
		brcs	bcd64_number6a
		inc		r16
		rjmp	bcd64_number6
bcd64_number6a:
		brts	bcd64_number6b
		set
		cpi		r16,'0'
		brne	bcd64_number6b
		ldi		r16,' '
		clt
bcd64_number6b:
		st		X+,r16
		subi  	r17,byte1(-100000)
		sbci  	r18,byte2(-100000)
		sbci  	r19,byte3(-100000)

; Zehntausenderstelle
		ldi   	r16,'0'
bcd64_number5:
		subi  	r17,byte1(10000)
		sbci  	r18,byte2(10000)
		sbci  	r19,byte3(10000)
		brcs	bcd64_number5a
		inc		r16
		rjmp	bcd64_number5
bcd64_number5a:
		brts	bcd64_number5b
		set
		cpi		r16,'0'
		brne	bcd64_number5b
		ldi		r16,' '
		clt
bcd64_number5b:
		st		X+,r16
		subi  	r17,byte1(-10000)
		sbci  	r18,byte2(-10000)
		sbci  	r19,byte3(-10000)

; Tausenderstelle
		ldi   	r16,'0'
bcd64_number4:
		subi  	r17, low(1000)
		sbci  	r18,high(1000)
		brcs	bcd64_number4a
		inc		r16
		rjmp	bcd64_number4
bcd64_number4a:
		brts	bcd64_number4b
		set
		cpi		r16,'0'
		brne	bcd64_number4b
		ldi		r16,' '
		clt	
bcd64_number4b:
		st		X+,r16
		subi  	r17,byte1(-1000)
		sbci  	r18,byte2(-1000)

; Hunderterstelle
		ldi   	r16,'0'
bcd64_number3:
		subi  	r17, low(100)
		sbci  	r18,high(100)
		brcs	bcd64_number3a
		inc		r16
		rjmp	bcd64_number3
bcd64_number3a:
;------------------------------------
		brts	bcd64_number3b
		set
		cpi		r16,'0'
		brne	bcd64_number3b
		ldi		r16,' '
		clt
;------------------------------------
bcd64_number3b:
		st		X+,r16
		subi  	r17,-100

; Zehnerstelle
		ldi		r16, '0'
bcd64_number2:
		subi	r17, 10
		brcs	bcd64_number2a
		inc		r16
		rjmp	bcd64_number2
bcd64_number2a:
;------------------------------------
		brts	bcd64_number2b
		cpi		r16,'0'
		brne	bcd64_number2b
		ldi		r16,' '
;------------------------------------
bcd64_number2b:
		st		X+,r16
		subi  	r17,-(10 + '0')
		st		X+,r17
		ldi		r17,0
		st		X+,r17
; fertig: Stack wieder aufräumen
		clt
		ldi		XL,byte1(BCD_VALUE)
		ldi		XH,byte2(BCD_VALUE)
		ld		r16,X+
		cpi		r16,' '
		breq	PC-2
		sbiw	X,2
		pop		r16
		st		X,r16
		pop		XH
		pop		XL
		pop		r24
		pop		r23
		pop		r22
		pop		r21
		pop		r20
		pop		r19
		pop		r18
		pop		r17
		pop		r16
		ret
